searchNodes=[{"doc":"Generates controller, views, and context for an HTML resource in Temple. mix temple . gen . html Accounts User users name :string age :integer The first argument is the context module followed by the schema module and its plural name (used as the schema table name). The context is an Elixir module that serves as an API boundary for the given resource. A context often holds many related resources. Therefore, if the context already exists, it will be augmented with functions for the given resource. Note: A resource may also be split over distinct contexts (such as Accounts.User and Payments.User ). The schema is responsible for mapping the database fields into an Elixir struct. Overall, this generator will add the following files to lib/ : a context module in lib/app/accounts.ex for the accounts API a schema in lib/app/accounts/user.ex , with an users table a view in lib/app_web/views/user_view.ex a controller in lib/app_web/controllers/user_controller.ex default CRUD templates in lib/app_web/templates/user A migration file for the repository and test files for the context and controller features will also be generated. The location of the web files (controllers, views, templates, etc) in an umbrella application will vary based on the :context_app config located in your applications :generators configuration. When set, the Phoenix generators will generate web files directly in your lib and test folders since the application is assumed to be isolated to web specific functionality. If :context_app is not set, the generators will place web related lib and test files in a web/ directory since the application is assumed to be handling both web and domain specific functionality. Example configuration: config :my_app_web , :generators , context_app : :my_app Alternatively, the --context-app option may be supplied to the generator: mix phx . gen . html Sales User users -- context - app warehouse Web namespace By default, the controller and view will be namespaced by the schema name. You can customize the web module namespace by passing the --web flag with a module name, for example: mix phx . gen . html . temple Sales User users -- web Sales Which would generate a lib/app_web/controllers/sales/user_controller.ex and lib/app_web/views/sales/user_view.ex . Generating without a schema or context file In some cases, you may wish to bootstrap HTML templates, controllers, and controller tests, but leave internal implementation of the context or schema to yourself. You can use the --no-context and --no-schema flags for file generation control. table By default, the table name for the migration and schema will be the plural name provided for the resource. To customize this value, a --table option may be provided. For example: mix phx . gen . html . temple Accounts User users -- table cms_users binary_id Generated migration can use binary_id for schema's primary key and its references with option --binary-id . Default options This generator uses default options provided in the :generators configuration of your application. These are the defaults: config :your_app , :generators , migration : true , binary_id : false , sample_binary_id : &quot;11111111-1111-1111-1111-111111111111&quot; You can override those options per invocation by providing corresponding switches, e.g. --no-binary-id to use normal ids despite the default configuration or --migration to force generation of the migration. Read the documentation for phx.gen.schema for more information on attributes.","ref":"Mix.Tasks.Temple.Gen.Html.html","title":"Mix.Tasks.Temple.Gen.Html","type":"task"},{"doc":"","ref":"Mix.Tasks.Temple.Gen.Html.html#inputs/1","title":"Mix.Tasks.Temple.Gen.Html.inputs/1","type":"function"},{"doc":"Generates a Phoenix layout file in Temple. mix temple . gen . layout","ref":"Mix.Tasks.Temple.Gen.Layout.html","title":"Mix.Tasks.Temple.Gen.Layout","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Temple.Gen.Layout.html#run/1","title":"Mix.Tasks.Temple.Gen.Layout.run/1","type":"function"},{"doc":"Generates LiveView, templates, and context for a resource. mix temple . gen . live Accounts User users name :string age :integer The first argument is the context module followed by the schema module and its plural name (used as the schema table name). The context is an Elixir module that serves as an API boundary for the given resource. A context often holds many related resources. Therefore, if the context already exists, it will be augmented with functions for the given resource. When this command is run for the first time, a ModalComponent and LiveHelpers module will be created, along with the resource level LiveViews and components, including an IndexLive , ShowLive , FormComponent for the new resource. Note: A resource may also be split over distinct contexts (such as Accounts.User and Payments.User ). The schema is responsible for mapping the database fields into an Elixir struct. It is followed by an optional list of attributes, with their respective names and types. See mix phx.gen.schema for more information on attributes. Overall, this generator will add the following files to lib/ : a context module in lib/app/accounts.ex for the accounts API a schema in lib/app/accounts/user.ex , with an users table a view in lib/app_web/views/user_view.ex a LiveView in lib/app_web/live/user_live/show_live.ex a LiveView in lib/app_web/live/user_live/index_live.ex a LiveComponent in lib/app_web/live/user_live/form_component.ex a LiveComponent in lib/app_web/live/modal_component.ex a helpers modules in lib/app_web/live/live_helpers.ex The context app A migration file for the repository and test files for the context and controller features will also be generated. The location of the web files (LiveView's, views, templates, etc) in an umbrella application will vary based on the :context_app config located in your applications :generators configuration. When set, the Phoenix generators will generate web files directly in your lib and test folders since the application is assumed to be isolated to web specific functionality. If :context_app is not set, the generators will place web related lib and test files in a web/ directory since the application is assumed to be handling both web and domain specific functionality. Example configuration: config :my_app_web , :generators , context_app : :my_app Alternatively, the --context-app option may be supplied to the generator: mix temple . gen . live Sales User users -- context - app warehouse Web namespace By default, the controller and view will be namespaced by the schema name. You can customize the web module namespace by passing the --web flag with a module name, for example: mix temple . gen . live Sales User users -- web Sales Which would generate a LiveViews inside lib/app_web/live/sales/user_live/ and a view at lib/app_web/views/sales/user_view.ex . Customising the context, schema, tables and migrations In some cases, you may wish to bootstrap HTML templates, LiveViews, and tests, but leave internal implementation of the context or schema to yourself. You can use the --no-context and --no-schema flags for file generation control. You can also change the table name or configure the migrations to use binary ids for primary keys, see mix phx.gen.schema for more information.","ref":"Mix.Tasks.Temple.Gen.Live.html","title":"Mix.Tasks.Temple.Gen.Live","type":"task"},{"doc":"Temple syntax is available inside the temple , and is compiled into EEx at build time. Usage temple do # You can define attributes by passing a keyword list to the element, the values can be literals or variables. class = &quot;text-blue&quot; id = &quot;jumbotron&quot; div class : class , id : id do # Text nodes can be emitted as string literals or variables. &quot;Bob&quot; id end # if and unless expressions can be used to conditionally render content if 5 &gt; 0 do p do &quot;Greater than 0!&quot; end end unless 5 &gt; 0 do p do &quot;Less than 0!&quot; end end # You can loop over items using for comprehensions for x &lt;- 0 .. 5 do div do x end end # You can use multiline anonymous functions, like if you&#39;re building a form in Phoenix form_for @changeset , Routes . user_path ( @conn , :create ) , fn f -&gt; &quot;Name: &quot; text_input f , :name end # You can explicitly emit a tag by prefixing with the Temple module Temple . div do &quot;Foo&quot; end # You can also pass children as a do key instead of a block div do : &quot;Alice&quot; , class : &quot;text-yellow&quot; end Configuration Mode There are two &quot;modes&quot;, :normal (the default) and :live_view . In :live_view mode, Temple emits markup that uses functions provided by Phoenix LiveView in order to be fully &quot;diff trackable&quot;. config :temple , :mode , :normal # default # or config :temple , :mode , :live_view Aliases You can add an alias for an element if there is a namespace collision with a function. If you are using Phoenix.HTML , there will be namespace collisions with the &lt;link&gt; and &lt;label&gt; elements. config :temple , :aliases , label : :_label , link : :_link , select : :_select temple do _label do &quot;Email&quot; end _link href : &quot;/css/site.css&quot; end This will result in: &lt;label&gt; Email &lt;/label&gt; &lt;link href=&quot;/css/site.css&quot;&gt;","ref":"Temple.html","title":"Temple","type":"module"},{"doc":"Compiles temple markup into a quoted expression using the given EEx Engine. Returns the same output that Phoenix templates output into the render/1 function of their view modules. Usage require Temple Temple . compile Phoenix.HTML.Engine do div class : @class do &quot;Hello, world!&quot; end end","ref":"Temple.html#compile/2","title":"Temple.compile/2","type":"macro"},{"doc":"Context for temple markup. Returns an EEx string that can be passed into an EEx template engine. Usage import Temple temple do div class : @class do &quot;Hello, world!&quot; end end # &lt;div class=&quot;&lt;%= @class %&gt;&quot;&gt; # Hello, world! # &lt;/div&gt;","ref":"Temple.html#temple/1","title":"Temple.temple/1","type":"macro"},{"doc":"API for defining components. Component modules are basically normal Phoenix View modules. The contents of the render macro are compiled into a render/2 function. This means that you can define functions in your component module and use them in your component markup. Since component modules are view modules, the assigns you pass to the component are accessible via the @ macro and the assigns variable. You must require Temple.Component in your views that use components, as the c and slot generate markup that uses macros provided by Temple. Components defmodule MyAppWeb.Components.Flash do import Temple.Component def border_class ( :info ) , do : &quot;border-blue-500&quot; def border_class ( :warning ) , do : &quot;border-yellow-500&quot; def border_class ( :error ) , do : &quot;border-red-500&quot; def border_class ( :success ) , do : &quot;border-green-500&quot; render do div class : &quot;border rounded p-2 \#{ assigns [ :class ] } \#{ border_class ( @message_type ) } &quot; do slot :default end end end Components are used by calling the c keyword, followed by the component module and any assigns you need to pass to the template. c is a compile time keyword , not a function or a macro, so you won't see it in the generated documention. c MyAppWeb.Components.Flash , class : &quot;font-bold&quot; , message_type : :info do ul do for info &lt;- infos do li class : &quot;p-4&quot; do info . message end end end end Since components are just modules, if you alias your module, you can use them more ergonomically. # lib/my_app_web/views/page_view.ex alias MyAppWeb.Components.Flex # lib/my_app_web/templates/page/index.html.exs c Flex , class : &quot;justify-between items center&quot; do for item &lt;- items do div class : &quot;p-4&quot; do item . name end end end Slots Components can use slots, which are named placeholders for markup that can be passed to the component by the caller. Slots are invoked by using the slot keyword, followed by the name of the slot and any assigns you'd like to pass into the slot. slot is a compile time keyword , not a function or a macro, so you won't see it in the generated documention. defmodule Flex do import Temple.Component render do div class : &quot;flex \#{ @class } &quot; do slot :default end end end You can also use &quot;named slots&quot;, which allow for data to be passed back into them. This is very useful when a component needs to pass data from the inside of the component back to the caller, like when rendering a form in LiveView. defmodule Form do import Temple.Component render do form = form_for ( @changeset , @action , assigns ) form slot :f , form : form &quot;&lt;/form&gt;&quot; end end By default, the body of a component fills the :default slot. Named slots can be defined by invoking the slot keyword with the name of the slot and a do block. You can also pattern match on any assigns that are being passed into the slot as if you were defining an anonymous function. slot is a compile time keyword , not a function or a macro, so you won't see it in the generated documention. # lib/my_app_web/templates/post/new.html.lexs c Form , changeset : @changeset , action : @action , class : &quot;form-control&quot; , phx_submit : :save , phx_change : :validate do slot :f , %{ form : f } do label f do &quot;Widget Name&quot; text_input f , :name , class : &quot;text-input&quot; end submit &quot;Save!&quot; end end","ref":"Temple.Component.html","title":"Temple.Component","type":"module"},{"doc":"Defines a component module. This macro makes it easy to define components without creating a separate file. It literally inlines a component module. Since it defines a module inside of the current module, local function calls from the outer module won't be available. For convenience, the outer module is aliased for you, so you can call remote functions with a shorter module name. Usage def MyAppWeb.SomeView do use MyAppWeb.SomeView , :view import Temple.Component , only : [ defcomp : 2 ] # define a function in outer module def foobar ( ) , do : &quot;foobar&quot; # define a component defcomp Button do button id : SomeView . foobar ( ) , # `MyAppWeb.SomeView` is aliased for you. class : &quot;text-sm px-3 py-2 rounded \#{ assigns [ :extra_classes ] } &quot; , type : &quot;submit&quot; do slot :default end end end # use the component in a SomeView template. Or else, you must alias `MyAppWeb.SomeView.Button` c Button , extra_classes : &quot;border-2 border-red-500&quot; do &quot;Submit!&quot; end","ref":"Temple.Component.html#defcomp/2","title":"Temple.Component.defcomp/2","type":"macro"},{"doc":"Defines a component template. Usage defmodule MyAppWeb.Components.Flash do import Temple.Component def border_class ( :info ) , do : &quot;border-blue-500&quot; def border_class ( :warning ) , do : &quot;border-yellow-500&quot; def border_class ( :error ) , do : &quot;border-red-500&quot; def border_class ( :success ) , do : &quot;border-green-500&quot; render do div class : &quot;border rounded p-2 \#{ assigns [ :class ] } \#{ border_class ( @message_type ) } &quot; do slot :default end end end","ref":"Temple.Component.html#render/1","title":"Temple.Component.render/1","type":"macro"},{"doc":"The Temple HTML engine makes it possible to use Temple with Phoenix controllers. To get started, you will configure Phoenix to use this module for .exs files. # config.exs config :phoenix , :template_engines , # this will work for files named like `index.html.exs` exs : Temple.Engine # config/dev.exs config :your_app , YourAppWeb.Endpoint , live_reload : [ patterns : [ ~r&quot;lib/myapp_web/(live|views)/.*(ex|exs|lexs)$&quot; , ~r&quot;lib/myapp_web/templates/.*(eex|exs|lexs)$&quot; ] ] # my_app/ # lib/ # my_app/ # my_app_web/ # templates/ # posts/ # show.html.exs Now you can get started by writing exs files in the templates directory and they will be compiled as you would expect.","ref":"Temple.Engine.html","title":"Temple.Engine","type":"module"},{"doc":"Callback implementation for Phoenix.Template.Engine.compile/2 .","ref":"Temple.Engine.html#compile/2","title":"Temple.Engine.compile/2","type":"function"},{"doc":"The Temple LiveView engine makes it possible to use Temple with Phoenix LiveView. To get started, you will configure Phoenix to use this module for .lexs files. # config.exs config :phoenix , :template_engines , # this will work for files named like `index.html.lexs` # you can enable Elixir syntax highlighting in your editor for this extension lexs : Temple.LiveViewEngine # config/dev.exs config :your_app , YourAppWeb.Endpoint , live_reload : [ patterns : [ ~r&quot;lib/myapp_web/(live|views)/.*(ex|exs|lexs)$&quot; , ~r&quot;lib/myapp_web/templates/.*(eex|exs|lexs)$&quot; ] ] # my_app/ # lib/ # my_app/ # my_app_web/ # live/ # posts_live/ # show.ex # show.html.lexs Now you can get started by writing lexs files co-located with your live views and they will be compiled as you would expect.","ref":"Temple.LiveViewEngine.html","title":"Temple.LiveViewEngine","type":"module"},{"doc":"Callback implementation for Phoenix.Template.Engine.compile/2 .","ref":"Temple.LiveViewEngine.html#compile/2","title":"Temple.LiveViewEngine.compile/2","type":"function"},{"doc":"You are looking at the README for the main branch. The README for the latest stable release is located here . Temple is a DSL for writing HTML and EEx using Elixir. You're probably here because you want to use Temple to write Phoenix templates, which is why Temple includes a Phoenix template engine .","ref":"readme.html","title":"","type":"extras"},{"doc":"Add temple to your list of dependencies in mix.exs : def deps do [ { :temple , &quot;~&gt; 0.6.2&quot; } , { :phoenix_view , github : &quot;phoenixframework/phoenix_view&quot; } , { :phoenix_live_view , github : &quot;phoenixframework/phoenix_live_view&quot; } # currently requires an unreleased version of phoenix_live_view if you are using live view ] end or def deps do [ { :temple , github : &quot;mhanberg/temple&quot; } ] end","ref":"readme.html#installation","title":" - Installation","type":"extras"},{"doc":"Currently Temple has the following things on which it won't compromise. Will only work with valid Elixir syntax. Should always work with normal EEx, as well as Phoenix and Phoenix LiveView.","ref":"readme.html#goals","title":" - Goals","type":"extras"},{"doc":"Using Temple is as simple as using the DSL inside of an temple/1 block. This returns an EEx string at compile time. See the documentation for more details. use Temple temple do h2 do : &quot;todos&quot; ul class : &quot;list&quot; do for item &lt;- @items do li class : &quot;item&quot; do div class : &quot;checkbox&quot; do div class : &quot;bullet hidden&quot; end div do : item end end end script do : &quot;&quot;&quot; function toggleCheck({currentTarget}) { currentTarget.children[0].children[0].classList.toggle(&quot;hidden&quot;); } let items = document.querySelectorAll(&quot;li&quot;); Array.from(items).forEach(checkbox =&gt; checkbox.addEventListener(&quot;click&quot;, toggleCheck)); &quot;&quot;&quot; end Components Temple components provide an ergonomic API for creating flexible and reusable views. Unlike normal partials, Temple components can take slots, which are similar Vue . For example, if I were to define a Card component, I would create the following module. defmodule MyAppWeb.Components.Card do import Temple.Component render do section do div do slot :header end div do slot :default end div do slot :footer end end end end And we could use the component like so # lib/my_app_web/views/page_view.ex alias MyAppWeb.Components.Card # lib/my_app_web/templates/page/index.html.exs c Card do slot :header do @user . full_name end @user . bio slot :footer do a href : &quot;https://twitter.com/ \#{ @user . twitter } &quot; do &quot;@ \#{ @user . twitter } &quot; end a href : &quot;https://github.com/ \#{ @user . github } &quot; do &quot;@ \#{ @user . github } &quot; end end end Phoenix templates To use temple as a Phoenix Template engine, you'll need to configure the right file extensions with the right Temple engine. # config.exs config :phoenix , :template_engines , exs : Temple.Engine # or for LiveView support # this will work for files named like `index.html.lexs` # you can enable Elixir syntax highlighting in your editor lexs : Temple.LiveViewEngine # If you&#39;re going to be using live_view, make sure to set the `:mode` config :temple , :mode , :live_view # defaults to normal # config/dev.exs config :your_app , YourAppWeb.Endpoint , live_reload : [ patterns : [ ~r&quot;lib/myapp_web/(live|views)/.*(ex|exs|lexs)$&quot; , ~r&quot;lib/myapp_web/templates/.*(eex|exs|lexs)$&quot; ] ] # app.html.exs html lang : &quot;en&quot; do head do meta charset : &quot;utf-8&quot; meta http_equiv : &quot;X-UA-Compatible&quot; , content : &quot;IE=edge&quot; meta name : &quot;viewport&quot; , content : &quot;width=device-width, initial-scale=1.0&quot; title do : &quot;YourApp · Phoenix Framework&quot; link rel : &quot;stylesheet&quot; , href : Routes . static_path ( @conn , &quot;/css/app.css&quot; ) end body do header do section class : &quot;container&quot; do nav role : &quot;navigation&quot; do ul do li do : a ( &quot;Get Started&quot; , href : &quot;https://hexdocs.pm/phoenix/overview.html&quot; ) end end a href : &quot;http://phoenixframework.org/&quot; , class : &quot;phx-logo&quot; do img src : Routes . static_path ( @conn , &quot;/images/phoenix.png&quot; ) , alt : &quot;Phoenix Framework Logo&quot; end end end main role : &quot;main&quot; , class : &quot;container&quot; do p class : &quot;alert alert-info&quot; , role : &quot;alert&quot; , compact : true , do : get_flash ( @conn , :info ) p class : &quot;alert alert-danger&quot; , role : &quot;alert&quot; , compact : true , do : get_flash ( @conn , :error ) render @view_module , @view_template , assigns end script type : &quot;text/javascript&quot; , src : Routes . static_path ( @conn , &quot;/js/app.js&quot; ) end end Tasks temple.gen.layout Generates the app layout. temple.gen.html Generates the templates for a resource. Formatter To include Temple's formatter configuration, add :temple to your .formatter.exs . [ import_deps : [ :temple ] , inputs : [ &quot;*.{ex,exs}&quot; , &quot;priv/*/seeds.exs&quot; , &quot;{config,lib,test}/**/*.{ex,exs,lexs}&quot; ] , ]","ref":"readme.html#usage","title":" - Usage","type":"extras"},{"doc":"Introducing Temple: An elegant HTML library for Elixir and Phoenix Temple, AST, and Protocols","ref":"readme.html#related","title":" - Related","type":"extras"}]